Node-Dexicon
=======

A powerful solution for lexicon-data
------------------------------------

### Welcome to the repository ###

* Node-Dexicon is a fast, easy-to-use module for retrieval of lexicon-data. Includes simple Rest API for javascript clients. This module has an in-memory loki-js lexicon, which applies a subset of Wordnet 3.0. Node-Dexicon includes:
  :Words, definitions, synonyms, antonyms, and related data
  :Relational data on linked-words(wn-semlinks), such as *hypernyms*, *hyponyms*, *holonyms*, and *meronyms*.

  Reasons to use dexicon:

  1.Speed:an in-mem lexicon means fast results with extensive data
  2.Versatility:use dexicon on server side, or access the rest-api with a javascript client

  About size and memory:

   -Weighs several-hundred MB or more and requires high-level of RAM

Our goal with dexicon is to provide an easy-to-use kit for access of word-related-data.

# Contributions #

[![Donate](https://img.shields.io/badge/Donate-PayPal-green.svg)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=NT2Y5YZJSYC5C)


* Version 1.2.0

### How do I get set up? ###

* nodejs
* npm install node-dexicon


### Module usage ###

    //* Instantiate the dexicon module:

        var dexicon_module = require('node-dexicon')(8082 /*port number*/); //default port is 80

        //module will take several seconds to instantiate an in-mem lexicon, requires mucho ram on node

### Rest-Api usage: word request examples ###


    //* request all data for words: cat and dog

        $.getJSON('<#app_url>/dexicon/api/deep?words=cat,dog', function(data){

         console.log("Got json data:" + JSON.stringify(data));

        });

    //* request statistics data for synsetids from existing word request

        $.getJSON('<#app_url>/dexicon/api/statistics?synsetids=<id-value-1>,<id-value-2>', function(data){

        console.log("Got json data:" + JSON.stringify(data));

        });


### rest-Api:uris: ###

    /dexicon/api/basic  : get only the basic word-data

    /dexicon/api/deep   : deep response of all data pertaining to a word- This option will retrieve deep results

    /*searching the word 'lama' brings results for lama >> mammal >> quadriped >> animal >> animate-being */

    /dexicon/api/statistics : get bnc word-usage statistics for words

    /dexicon/api/samples : samples of word-usage

    /dexicon/api/semlinks : get semlinks of a word, such as hypernyms, hyponyms

### Api:parameters ###

    'words', as in 'http://my_url?words=word1,word2,word3'

    'synsetids', as in 'http://my_url?synsetids=s1,s2,s3' //synsetids would usually come from an existing data request

### Who is the owner of project? ###

    * Jordan E. Blake  :: jordan9991080@gmail.com
