
/* Copyright Jordan E. Blake - All Rights Reserved
 *
 */

/*
 Express and http modules:
 */

/*************/



  var jstr = function(obj) {
    return JSON.stringify(obj, null, 2);
  };

(function() {



  const wordApi = {

        stack:[],
        words: false,
        semlinks: false,
        samples: false,
        stats: false,
        db:undefined,
        start:function(callback){

                  wordnetLoki = require('./dexicon/loki-dexicon.js')
                      .init(
                        'loki.dexicon',
                        ['wordsspecial', 'semlinksspecial', 'samplesspecial', 'statisticsspecial']
                        , function(){

                          wordApi.save = function(){
                            wordnetLoki.save();
                          };

                          callback.bind(wordApi).call();

                          wordApi.db = wordnetLoki.db;

                        });
        },

        getWordsByLexdomainname: function(lexdomainname) {

          var wordDataOut = [];

          this.words = wordnetLoki.tables['wordsspecial'] || wordnetLoki.db.getCollection('wordsspecial');

          for (var x = 0; x < words.length; x++) {

            var data = this.words.find({
              lexdomainname: lexdomainname
            });

            for (var y = 0; y < data.length; y++) {


              var wordObj = {
                word: data[y]
              };

              if (wordDataOut.indexOf(wordObj) === -1 && wordObj.hasOwnProperty(lexdomainname)) {

                wordDataOut.push(wordObj.lexdomainname);
              }
            }
          }

          return wordDataOut;

        },

        getWordsByLemmas: function(words) {

          var wordDataOut = [];

        this.words = wordnetLoki.tables['wordsspecial'] || wordnetLoki.db.getCollection('wordsspecial');


          for (var x = 0; x < words.length; x++) {


            /*
            var all_data = this.words.chain().simplesort('lemma').data(), ct = 0, walk_speed = 5000;

            console.log('TOtal Words::' + all_data.length);

            while(ct < all_data.length)
            {
              console.log(JSON.stringify(all_data[ct]));
              ct += walk_speed;
            }

            */

            var data = this.words.find({
              lemma: words[x]
            });

            for (var y = 0; y < data.length; y++) {

              if (data[y].hasOwnProperty('lemma')) {

                data[y].titleTag = data[y].lemma;

              }

              var wordObj = {
                word: data[y]
              };

              if (wordDataOut.indexOf(wordObj) === -1) {

                wordDataOut.push(wordObj);
              }


            }

          }

          return wordDataOut;

        },

        getWordsBySynsetids: function(synsetids) {

          var wordDataOut = [];

          this.words = wordnetLoki.tables['wordsspecial'] || wordnetLoki.db.getCollection('wordsspecial');

          for (var x = 0; x < synsetids.length; x++) {

            var data = this.words.find({
              synsetid: synsetids[x]
            });

            for (var y = 0; y < data.length; y++) {

              data[y].titleTag = data[x].lemma;

              var wordObj = {
                word: data[y]
              };

              if (wordDataOut.indexOf(wordObj) === -1) {

                wordDataOut.push(wordObj);
              }
            }
          }

          return wordDataOut;

        },

        getSemlinksBySynsetid: function(synsetid, recursive) {

          var semlinks = [];

          this.semlinks = wordnetLoki.tables['semlinksspecial'] || wordnetLoki.db.getCollection('semlinksspecial');

          var semlinksPerRecursiveLimit = 10;

          var sid = parseInt(synsetid);

          this.allWords =  wordnetLoki.tables['wordsspecial'] || wordnetLoki.db.getCollection('wordsspecial');


          var _inst = this;

          var linkedWords = function(sid) {

            var obj = _inst.semlinks.find({
              synset1id: sid
            });

            return obj;

          };

          var data = linkedWords(sid);

          for (var z = 0; z < data.length; z++) {

            var obj = data[z];

            semlinks.push(data[z]);

          }

          if (recursive) {

            //get the UPTRAIL recursive semlinks IF totalWords < 20 , maxRecursive = 5; maxRecursiveRowPerResult: 50;

            for (var y = 0; y < semlinks.length; y++) {

              var word = semlinks[y];

              if (word.link.indexOf('hypernym') > -1 || word.link.indexOf('meronym') > -1) {

                var link = word.link,
                  sid = word.synset2id;


                var data = linkedWords(sid);


                if (data.length > 0) {


                  for (var z = 0; z < data.length; z++) {

                    //  console.log(data[z].link);

                    var obj = data[z];


                    if (obj.link === link && semlinks.indexOf(obj) === -1) {

                      semlinks.push(obj);

                      //code
                    }
                  }
                  //code
                }
              }
            }
          }
          return semlinks;
        },

        getSamplesBySynsetid: function(synsetid, wordid) {

          var samples = [];

          this.samples =  wordnetLoki.tables['samplesspecial'] || wordnetLoki.db.getCollection('samplesspecial');

          var data = [];

          if (wordid) {
            data = this.samples.find({
              wordid: wordid,
              synsetid: synsetid
            });
          } else {
            data = this.samples.find({
              wordid: wordid,
              synsetid: synsetid
            });
          }


          for (var z = 0; z < data.length; z++) {


            var obj = data[z];


            samples.push(obj);

          }
          return samples;
        },

        getStatisticsByWordidAndPos: function(wordid, pos) {

          this.stats =  wordnetLoki.tables['statsspecial'] || wordnetLoki.db.getCollection('statisticsspecial');

          var data = this.stats.find({
            wordid: wordid,
            pos: pos
          });

          var statistics = [];

          for (var z = 0; z < data.length; z++) {


            var obj = data[z];

            statistics.push(obj);

          }

          return statistics;

        }

    }

      //return the wordApi:

  module.exports = wordApi;

})();
